/***************************************
* Pyramid cp made by Lorgan
* Requested by Asia/schadenfreude
****************************************/

globalvar pyramidcp;
pyramidcp = id;

pyramidcp.enabled = false;

// Modify the base captimes and detect pyramid cp
object_event_add(ControlPointHUD, ev_create, 0, "
    if (string_lower(string_copy(global.currentMap, 1, 4)) == 'pcp_') {
        pyramidcp.enabled = true;
        timeLimit=global.timeLimitMins*30*60/2;
        timer=global.timeLimitMins*30*60/2;
        
        ControlPoint3.capTime = basetime*2;
        ControlPoint2.capTime = basetime*10;
        ControlPoint1.capTime = basetime*10;
        
        with(ControlPoint) {
            if (cp == 2) {
                cp = 1;
            }
        }
    } else {
        pyramidcp.enabled = false;
    }
    
    cp1Team = -1;
    cp1Capping = 0;
    cp1Locked = false;
    
");

// Make it all work by cheating the system
object_event_add(ControlPointHUD, ev_step, ev_step_normal, "
    if (global.pyramidcp.enabled) {
        if (global.cp[2].capping >= global.cp[2].capTime) {
            pointCapture(2);
            
            // Due to the nature of this 'hack', cp1 also triggers when cp2 triggers.
            if (!cp1Locked) {
                // Remove kill log entry
                with(KillLog) {
                    ds_list_delete(kills, ds_list_size(kills)-1);
                } 
                
                // Reset values       
                global.cp[1].team = cp1Team;
                global.cp[1].capping = cp1Capping;
                global.cp[1].locked = false;
                
                if (global.isHost) {
                    // Revert scores
                    with(Character) {
                        if(cappingPoint == global.cp[1]) {
                            if(player.team == global.cp[1].cappingTeam) {
                                player.stats[CAPS] -=1;
                                player.roundStats[CAPS] -=1;
                                player.stats[POINTS] -= 2;
                                player.roundStats[POINTS] -= 2;
                            }
                        }
                    }
                }
            }
        } else {
            // make a backup of cp1
            cp1Team = global.cp[1].team;
            cp1Capping = global.cp[1].capping;
            cp1Locked = global.cp[1].locked;
        }
    
        var count;
        count = 0;
        if (global.cp[1].team == TEAM_RED) {
            count += 1;
            global.cp[3].cp = 3;
        }
        if (global.cp[2].team == TEAM_RED) {
            count += 1;
            global.cp[3].cp = 2;
        }
        if (count == 2) {
            // Reset back to normal and disable pcp
            timer+=global.timeLimitMins*30*60/2;
            global.cp[2].cp = 2;
            global.cp[3].cp = 3;
            pyramidcp.enabled = false;
        }
    }
");